\begin{figure}[htbp]
\begin{center}
%% \[
%% \begin{array}[t]{c}
%% \infrule{SEQ}\\
%% \hoareI{v^*}{\pstateN}{e_1}{\prestate{2}}{\pstate{2}}{\reldef{2}}
%% \quad\quad \hoareI{v^*}{\pstate{2}}{e_2}{\prestate{3}}{\pstate{3}}{\reldef{3}} \\
%% \hline
%% \hoareI{v^*}{\pstateN}{e_1;e_2}{\prestate{2}{\wedge}\prestate{3}}{\pstate{3}}{\reldef{2}{\cup}\reldef{3}} \\
%% \end{array}
%% \]
%
%\qquad\qquad
%% \[
%% \begin{array}[t]{c}
%% \infrule{IF}\\
%% \hoareI{v^*}{\pstateN{\wedge}{w'}}{e_1}{\prestate{2}}{\pstate{2}}{\reldef{2}}
%% \quad\quad \hoareI{v^*}{\pstateN{\wedge}{\neg}w'}{e_2}{\prestate{3}}{\pstate{3}}{\reldef{3}} \\
%% \hline
%% \hoareI{v^*}{\pstateN}{\myif{w}{e_1}{e_2}}{\prestate{2}{\wedge}\prestate{3}}{\pstate{2}{\vee}\pstate{3}}{\reldef{2}{\cup}\reldef{3}} \\
%% \end{array}
%% \]
%
%% \[
%% %\renewcommand{\arraystretch}{1.1}
%% \begin{array}[t]{c}
%% %
%% \infrule{ASSIGN}\\
%% \hoareI{v^*}{\pstateN}{e}{\prestate{2}}{\pstate{2}}{\reldef{2}}
%% \quad\quad \pstate{3} {=} \exists \res \cdot
%% (\pstate{2} ~{\wedge}_{u}~ u'{=}\res)\\
%% \hline
%% \hoareI{v^*}{\pstateN}{u{:=}e}{\prestate{2}}{\pstate{3}}{\reldef{2}}
%% \end{array}
%% %\qquad
%% \]
%\qquad\qquad
\[
\begin{array}[t]{c}
\infrule{METH{-}CALL}\\
\!\! t_0 ~\myit{mn}~ (\code{ref}~(t_i~v_i)_{i=1}^{m-1},(t_j~v_j)_{j=m}^{n}) ~~ {\pre}~~{\post}
%~\cdots~ 
~\{c\}
\in {\defprog} \\
\rho {=}[v'_k/v_k]_{k=1}^{n} \quad {\pre'} = \rho{(\pre)}
\quad\quad W{=}\{v_1,\dots,v_{m-1}\} \quad V{=}\{v_m,\dots,v_n\}\\
\entailIKV{v^*}{\pstateN}{\emp}{\emptyset}{\pre'}
{\prestate{2}}{\pstate{2}}{\reldef{2}}
\quad\quad \pstate{3}{=}(\pstate{2}~{\wedge}~{\nochange(V)})~~{\sep}_{{V}{\cup}{W}}~{\post}\\
\hline
\hoareI{v^*}{\pstateN}{\myit{mn}(v_1,\dots,v_{m-1},v_m,...v_n)}
{\prestate{2}}{\pstate{3}}{\reldef{2}}
\end{array}
\]
\[
\begin{array}[t]{c}
%
\infrule{METH{-}DEF}\\
\hoareI{v^*,v_{rel}^*}{\pre {\wedge} \bigwedge(u'{=}u)^*}{c}{\prestate{2}}{\pstate{2}}{\reldef{2}}
\quad\quad \entailIKV{v^*,v_{rel}^*}{\pstate{2}}{\emp}{\emptyset}{\post}{\prestate{3}}{\pstate{3}}{\reldef{3}} \\
\rho_1=\myit{infer\_pre}(\reldef{2}{\cup}\reldef{3}) \qquad
\rho_2=\myit{infer\_post}(\reldef{2}{\cup}\reldef{3})\\
{\pre^n}= \rho_1(\pre{\wedge}\prestate{2}{\wedge}\prestate{3})
\qquad
{\post^n}= \rho_2(\post{\sep}\pstate{3}) \\
\hline
\vdash ~ t_0 ~\myit{mn}~((t~u)^*)
  ~\code{infer\,[}{v^*,v_{rel}^*}\code{]}~{\pre}~{\post}~\{c\}~{\leadsto}~{{\pre^n}}~{{\post^n}}\hide{;}
\end{array}
\]
\end{center}
\caption{Hoare Rules with Bi-Abduction}
\label{fig.hoare}
\end{figure}
